/*
 *  Copyright 2018 Alexey Andreev.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.teavm.jso.dom.types;

import org.teavm.jso.JSIndexer;
import org.teavm.jso.JSObject;
import org.teavm.jso.JSProperty;

public interface DOMTokenList extends JSObject {
    @JSProperty
    int getLength();

    @JSIndexer
    String item(int index);

    boolean contains(String token);

    void add(String token);

    void add(String token1, String token2);

    void add(String... tokens);

    void remove(String token);

    void remove(String token1, String token2);

    void remove(String... tokens);

    boolean toggle(String token);
}
